# Отчёт по лабораторной работе №2

Выполнила: студентка гр. ИСЭбд-41 Островская Софья.

Вариант программы 1: 

4. Формирует файл `/var/result/data.txt` так, что каждая строка файла - количество символов в именах файлов из каталога `/var/data`.

Вариант программы 2: 

0. Сохраняет произведение первого и последнего числа из файла `/var/data/data.txt` в `/var/result/result.txt`.

## Создание приложений

Создадим 2 приложения.
Был выбран язык C# и технология .NET 5.

Для создания обычных консольных приложений воспользуемся командами:

```sh
dotnet new console -o worker-1
dotnet new console -o worker-2
```

Согласно варианту, программа 1 должна сформировать файл `/var/result/data.txt`, в который построчно будут записаны числа, равные количеству символов в именах файлах каталога `/var/data`.

[Исходный текст программы worker-1](worker-1/Program.cs)

Согласно варианту, программа 2 должна взять первое и последнее число из файла `/var/data/data.txt`, затем выполнить операцию произведения и записать результат в `/var/result/result.txt`.

[Исходный текст программы worker-2](worker-2/Program.cs)

Дополнительно создан файл [.gitignore](.gitignore) для того, чтобы не закоммитить в git ничего лишнего.

## Настройка окружения

Для связи двух приложений воспользуемся следующей схемой:

1. Каталог `./data` должен быть примонтирован в каталог `/var/data` для программы 1.
   Оттуда будут браться исходные данные.
2. Каталог `./result-1` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складываться промежуточные данные.
3. Каталог `./result-1` также должен быть примонтирован в каталог `/var/data` для программы 2.
   Оттуда будут браться промежуточные результаты.
4. Каталог `./result` должен быть примонтирован в каталог `/var/result` для программы 2.
   Туда будут складывать результаты финальной обработки.

Для каждой программы были созданы файлы Dockerfile ([программа 1](worker-1/Dockerfile), [программа 2](worker-2/Dockerfile)) с подробным описанием процесса сборки.

Был создан файл [docker-compose.yml](docker-compose.yml), в котором указан манифест для запуска распределённого приложения.

## Сборка и запуск

В каталог `./data` помещены 3 файла с различной длиной названия.

![](pic1.png)

На выходе, программа должна сначала записать числа [5 8 9], поскольку именно такую длину имеют файлы (вместе с расширением). А затем, умножив 5 на 9, получится результат программы 2, равный 45

Для запуска приложения необходимо ввести команду `docker compose up --build`.
Результат запуска после сборки:

![](pic2.png)

В результате в каталоге `./result` создался файл `result.txt` с содержимым `45`.

Изменение значений в файлах из каталога `./data` также изменяет содержимое в файлах из каталогов `./result-1` и `./result`.